#!/usr/local/bin/apl --script --

 ⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝
⍝
⍝ cf 2014-04-20 16:01:58 (GMT-7)
⍝
 ⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝⍝

⍝ function EMACS_NATIVE has ufun1 pointer 0!

⍝ function SQL has ufun1 pointer 0!

∇z←tn cf∆append data
 ⍝ Add a new component and return its component number.
 SQL[5] tn ⍝ begin
 'insert into component ( data, vers, oid ) values ( ?, ?, ? )' SQL[4,tn] (5↓2⎕tf 'data') (cf∆version tn) (cf⍙next_cn tn)
 z←cf∆max_cn tn
 SQL[6] tn ⍝ commit
∇

∇z←tn cf∆drop cn
 ⍝ Drop an existing component.
 'delete from component where oid = ?' SQL[4,tn] cn
 z←cn
∇

∇z←tn cf∆exists cn
 ⍝ Inquire whether a component exists.
 z←↑,'select 1 from component where oid = ?' SQL[3,tn] cn
∇

∇cf∆init
 ⍝ Ensure that the apl-sqlite library is loaded.
 →(0≠⎕nc 'SQL')/0
 cf⍙libpath ⎕fx 'SQL'
∇

∇z←cf∆max_cn tn
 ⍝ Return the component file's largest component number.
 z←↑'select current from max_cn where oid = 1' SQL[4,tn] ⍬
∇

∇z←tn cf∆read cn
 ⍝ Read an existing component.
 z←⍎,⊃'select data from component where oid = ?' SQL[3,tn] cn
∇

∇z←where cf∆replace data;tn;cn
 ⍝ Replace an existing component.
 tn←↑1↑where
 cn←↑1↓where
 'replace into component ( oid, data ) values ( ?, ? )' SQL[4,tn] (cn) (5↓2⎕tf 'data')
 z←cn
∇

∇z←cf∆tie path
 ⍝ Get a reference to a named component file. Create the file if needed.
 z←'sqlite' SQL[1] path
 'create table if not exists component ( data text, vers int )' SQL[4,z] ⍬
 'create table if not exists version ( current int )' SQL[4,z] ⍬
 'create table if not exists max_cn ( current int )' SQL[4,z] ⍬
 ⍝ Set the initial maximum component number only at file creation.
 →(1=↑,'select 1 from max_cn where oid = 1' SQL[3,z] ⍬)/skip
 'insert into max_cn ( oid, current ) values ( 1, ? )' SQL[4,z] (0)
 skip:
 ⍝ Set the component file version only at file creation.
 →(1=↑,'select 1 from version where oid = 1' SQL[3,z] ⍬)/0
 'insert into version ( oid, current ) values ( 1, ? )' SQL[4,z] (1)
∇

∇z←cf∆untie tn
 ⍝ Close the referenced component file.
 SQL[2] tn
 z←⍬
∇

∇z←cf∆version tn
 ⍝ Return the component file's version number.
 z←↑'select current from version where oid = 1' SQL[3,tn] ⍬
∇

∇z←cf⍙next_cn tn
 ⍝ Increment and return the component number.
 ⍝ This function is reserved to the implementation.
 'replace into max_cn ( oid, current ) values ( 1, ? )' SQL[4,tn] 1+cf∆max_cn tn
 z←cf∆max_cn tn
∇

Describe←6⍴0
  Describe[0+⍳6]←'∘∘∘∘∘∘'
  ((⎕IO+0)⊃Describe)←⊂52⍴0
  ((⎕IO+0)⊃Describe)[⍳46]←'A simple component file system on top of apl-s'
  ((⎕IO+0)⊃Describe)[46+⍳6]←'qlite.'
  ((⎕IO+1)⊃Describe)←⊂60⍴0
  ((⎕IO+1)⊃Describe)[⍳46]←'Written for GNU APL by David B. Lamkins <david'
  ((⎕IO+1)⊃Describe)[46+⍳14]←'@lamkins.net>.'
  ((⎕IO+2)⊃Describe)←32⍴'http://www.gnu.org/software/apl/'
  ((⎕IO+3)⊃Describe)←19⍴'http://lamkins.net/'
  ((⎕IO+4)⊃Describe)←37⍴'https://github.com/lokedhs/apl-sqlite'
  ((⎕IO+5)⊃Describe)←23⍴'https://www.sqlite.org/'
  Describe←6 1⍴Describe

cf⍙libpath←24⍴'apl-sqlite/lib_sqlite.so'

⎕CT←1E¯13

⎕FC←6⍴(,⎕UCS 46 44 8902 48 95 175)

⎕IO←1

⎕L←0

⎕LX←' '
  ⎕LX←0⍴⎕LX

⎕NLT←1⍴'C'

⎕PP←10

⎕PR←1⍴' '

⎕PS←0

⎕PW←80

⎕R←0

⎕RL←1

⎕TZ←-7

